/*
 * This code is automatically generated by MAG
 * Copyright (C) 2014 Chan Ngo, INRIA
 * chan.ngo@inria.fr
 */


/*
 * User's includes to cc file
 */

#include "bus.h"
#include "clk_tick.h"
#include "proci.h"
#include "procm.h"
#include "proco.h"
#include "sa_grp.h"
#include "monitor_ecs.h"

#include "reward.h"

/*
 * Monitor's formula:
 */

//	 PBLTL forumula: F <= #14400 (proci_status = 2 & number_sensors < 35) 
//	 clock(s): 
//			tickevent
//


/*
 * Constructor
 */

monitor_ecs0::monitor_ecs0(sc_core::mon_observer* obs, Clk_tick* obj0, Proci* obj1, Procm* obj2, Proco* obj3, Sa_grp* obj4) : sc_core::mon_prototype() {

  // Observer
  observer = obs;
  // Usertypes
  pnt_clktick = obj0;
  pnt_proci = obj1;
  pnt_procm = obj2;
  pnt_proco = obj3;
  pnt_sa = obj4;
  // Locations
  // Plocations
  // Value callbacks
  // Attributes - nothing to initialization
  // Event clocks
  tickevent = false;
  // Register with observer
  observer->register_monitor(this, &(pnt_clktick->e_tick));
}

/*
 * Destructor
 */

monitor_ecs0::~monitor_ecs0() {

}

/*
 * Simulate a step of the monitor.
 */

void
monitor_ecs0::step() {
  //Get command from standard input - stdin
  std::string cmd;

  while (true) {
    std::getline(std::cin, cmd);
    // Get quit command
    if (strcmp(cmd.c_str(), "#plasma-quit#") == 0) {
      sc_stop();
      std::cout << "\n# plasma-quit at " << sc_time_stamp() << " #\n" << std::endl;
      exit (0);
    }

    // Get an invalid command
    else if (strcmp(cmd.c_str(), "#plasma-newstate#") != 0) {
      // Wait for a valid command
      continue;
    }

    // Get a new state request
    else {
      // Process the command
      break;
    }
  }

  std::stringstream outputstate;
  outputstate.str ();
  outputstate << "\n# plasma-state [ (";


  // Log attributes values
  outputstate << "number_actuators";
  outputstate << " : ";
  outputstate << pnt_sa->actuators;
  outputstate << ", ";

  outputstate << "number_sensors";
  outputstate << " : ";
  outputstate << pnt_sa->sensors;
  outputstate << ", ";

  outputstate << "proci_reboot_number";
  outputstate << " : ";
  outputstate << pnt_proci->number_reboot;
  outputstate << ", ";

  outputstate << "proci_status";
  outputstate << " : ";
  outputstate << pnt_proci->proci_status;
  outputstate << ", ";

  outputstate << "procm_status";
  outputstate << " : ";
  outputstate << pnt_procm->procm_status;
  outputstate << ", ";

  outputstate << "proco_reboot_number";
  outputstate << " : ";
  outputstate << pnt_proco->number_reboot;
  outputstate << ", ";

  outputstate << "proco_status";
  outputstate << " : ";
  outputstate << pnt_proco->proco_status;
  outputstate << ", ";

  outputstate << "timeout_counts";
  outputstate << " : ";
  outputstate << pnt_procm->count;



  // Log event clocks - Boolean
  outputstate << ", ";
  if (tickevent) {
    outputstate << "tickevent";
    outputstate << " : ";
    outputstate << "true";
  }
  else {
    outputstate << "tickevent";
    outputstate << " : ";
    outputstate << "false";
  }


  // Log locations - Boolean


  // Log pattern locations - plocation - Boolean


  // Log callback values

  // reward variables and the corresponding time
  outputstate << ", ";
  
  bool down = ((pnt_proci->proci_status == 2 && pnt_sa->sensors < M_SENSOR) || (pnt_procm->count > MAX_COUNT) || 
               (pnt_proco->proco_status == 2 && pnt_sa->actuators < M_ACTUATOR) || (pnt_procm->procm_status == 0));
  bool danger = !down && (pnt_proci->proci_status == 1 || pnt_proco->proco_status == 1);
  bool up = !down && !danger;
  // reward up
  if (!rw_up_flag && down) {
    rw_up_flag = true;
  }
  if (up && !rw_up_flag) {
    rw_up = rw_up + 1;
  }
  outputstate << "reward_up";
  outputstate << " : ";
  outputstate << rw_up;
  outputstate << ", ";
  // reward danger
  if (!rw_danger_flag && down) {
    rw_danger_flag = true;
  }
  if (danger && !rw_danger_flag) {
    rw_danger = rw_danger + 1;
  }
  outputstate << "reward_danger";
  outputstate << " : ";
  outputstate << rw_danger;
  outputstate << ", ";
  // reward shutdown
  if (down) {
    rw_shutdown = rw_shutdown + 1;
  }
  outputstate << "reward_shutdown";
  outputstate << " : ";
  outputstate << rw_shutdown;

  // Send the logged state to stdout
  outputstate << ")" << " : ";
  outputstate << sc_time_stamp() ;
  outputstate << " ] #\n" << std::endl;
  std::cout << outputstate.str();
}


void
monitor_ecs0::callback_event_notified(sc_core::sc_event* event) {
  if (event == &(pnt_clktick->e_tick)) {
    tickevent = true;
  }

  step();

  if (event == &(pnt_clktick->e_tick)) {
    tickevent = false;
  }

}

// static instance variable
local_observer* local_observer::m_instance;



/*
 * Constructor
 */
local_observer::local_observer(unsigned int verbosity, Clk_tick* pnt_clktick, Proci* pnt_proci, Procm* pnt_procm, Proco* pnt_proco, Sa_grp* pnt_sa) : sc_core::mon_observer(verbosity) {

  monitor_ecs0* monitor_ecs0_inst = new monitor_ecs0(this, pnt_clktick, pnt_proci, pnt_procm, pnt_proco, pnt_sa);
  mons.push_back(monitor_ecs0_inst);

}

/*
 * Destructor
 */
local_observer::~local_observer() {

}
/*
 * Create instance
 */
local_observer* local_observer::createInstance(unsigned int verbosity, Clk_tick* pnt_clktick, Proci* pnt_proci, Procm* pnt_procm, Proco* pnt_proco, Sa_grp* pnt_sa) {

  if (m_instance == NULL) {
    m_instance = new local_observer(verbosity, pnt_clktick, pnt_proci, pnt_procm, pnt_proco, pnt_sa);  }

  return m_instance;

}

/*
 * Get instance
 */
local_observer* local_observer::getInstance() {

  return m_instance;

}
